﻿using System.Collections.ObjectModel;
using System.Linq;
using System.Windows.Input;
using InfragisticsExampleWithListInsteadOfObservableCollection.Commands;
using InfragisticsExampleWithListInsteadOfObservableCollection.Model;

namespace InfragisticsExampleWithListInsteadOfObservableCollection.ViewModel
{
     public class MyViewModel
    {
        public ClassViewModel ActiveClass { get; set; }

        public ICommand AddStudentCommand { get; set; }
        public ICommand RemoveStudentCommand { get; set; }

        public ObservableCollection<GenderViewModel> GenderCollection { get; }

        public MyViewModel(ClassViewModel classVm)
        {
            ActiveClass = classVm;
            AddStudentCommand = new RelayCommand(AddStudentCommand_Execute);
            RemoveStudentCommand = new RelayCommand(RemoveStudentCommand_Execute);
            GenderCollection = new ObservableCollection<GenderViewModel>
            {
                new GenderViewModel(new GenderObject{Id = 0, Name = "Unspecified"}),
                new GenderViewModel(new GenderObject{Id = 1, Name = "Female"}),
                new GenderViewModel(new GenderObject{Id = 2, Name = "Male"})
            };
        }

        void AddStudentCommand_Execute(object obj)
        {
            //ActiveClass.AddStudent(new StudentObject (ActiveClass.Students?.Count + 1 ?? 1, 1, "New student", new GenderObject() { Id = 0, Name = "Unspecified" }));
			ActiveClass.AddStudent(new StudentObject (ActiveClass.Students?.Count + 1 ?? 1, 1, "New student", this.GenderCollection[0].Gender));
        }

        void RemoveStudentCommand_Execute(object obj)
        {
            ActiveClass.RemoveStudent();
        }
    }
}
